{$R-,S-} {$ifdef FPC} {$mode tp} {$endif}

program db; {public domain, free for any use, nenies proprajho}

const perline: integer = 16; showofs: boolean = true;
var f: file; fname: string;

procedure getarg;
var num,errpos: integer;
const usagemsg = 'Usage:  db.exe [-q] myfile.dat' +
                 ' [number_of_bytes_per_line]';

  procedure grab(n: integer);
  begin fname := paramstr(n);
    val(paramstr(n+1),num,errpos);
    if (errpos=0) and (num <> 0) then perline := abs(num)
  end; {grab}

  function quiet: boolean; var s: string;
  begin s := paramstr(1);
    quiet := ((s[1]='-') or (s[1]='/')) and (upcase(s[2])='Q')
  end; {quiet}

begin
  case paramcount of
    0: begin writeln(usagemsg); halt(255) end;
    1: begin fname := paramstr(1) end;
    2: begin
         if quiet then begin
           showofs := false; fname := paramstr(2)
         end
         else grab(1)
       end;
    3: begin
         if quiet then begin
           showofs := false; grab(2)
         end
         else grab(1)
       end;
  end
end; {getarg}

procedure dump;
const hexofs: longint = 0; maxline = 80;
      table: string[16] = '0123456789ABCDEF';
var i: integer; line: string;
    buf: array [1..maxline] of byte; bytesread: word;

  function writelong(l: longint): string;
  const hex: string[8] = 'HHHHHHHH';
  var i: 1..8;
  begin
    for i := 8 downto 1 do begin
      hex[i] := table[(l and $0F)+1];
      l := l shr 4
    end;
    writelong := hex
  end; {writelong}
  
  function writebyte(b: byte): string;
  const hex: string[2] = 'HH';
  begin
    hex[2] := table[(b and $0F)+1];
    hex[1] := table[((b shr 4) and $0F)+1];
    writebyte := hex
  end; {writebyte}

begin {dump} if perline > maxline then perline := maxline;
  while not eof(f) do begin
    line := '';
    blockread(f,buf,perline,bytesread);
    for i := 1 to bytesread-1 do line := line + writebyte(buf[i]) + ' ';
    if showofs then write(writelong(hexofs),': ');
    writeln(line,writebyte(buf[bytesread]));
    inc(hexofs,bytesread)
  end;
  if showofs then writeln(writelong(hexofs))
end; {dump}

begin {main} getarg; assign(f,fname);
  filemode := 0; {$I-} reset(f,1); {$I+}
  if IOresult=0 then begin
    dump;
    close(f)
  end
  else begin
    writeln('''',fname,''' not found!');
    halt(1)
  end
end.
